/****************************************************************************************
*	Titel:		Hello World, Receive CAN message and show...                            *
*	Autor:		Werner                                                                  *
*	Datum:		04.07.2008																*
*	Purpose:	Receive CAN Message, Show with LED                                      *
*               Heartbeat LED blink with 2Hz											*
*	Software:	AVR-Studio 4.13 with Win-AVR 4.2.2 										*
*	Hardware:	ATMega128_Evoboard, AT90CAN128											*
*				LED1 on PA4/GND (LCD ConnectorST8,  + on Pin11/GND on Pin10)			*
*               LED2 on PA5/GND (LCD ConnectorST8,  + on Pin12/GND on Pin9)			*  
****************************************************************************************/

#include <avr/io.h>
#define F_CPU		16000000UL		//	16 MHz
#include <util/delay.h>

#include "my_main.h"



void delay(void)
{
      _delay_ms(1);
}

int main (void) {

   CAN_message msg0, msg1;
   uint32_t timer=0;

   Set2Output(DDRA, PA4);
   Set2Output(DDRA, PA5);

   CAN_init(83, RX);

   msg0.id = 0x000A ;
   msg0.idm = 0xffffffff ;
   msg0.data[0] = 0x0A ;
   msg0.data[1] = 0x01 ;
   msg0.data[2] = 0x02 ;
   msg0.data[3] = 0x03 ;
   msg0.data[4] = 0x04 ;
   msg0.data[5] = 0x05 ;
   msg0.data[6] = 0x06 ;
   msg0.data[7] = 0x07 ;


// Receive Message
   msg1.idm      = 0xffffffff;             // Es kommt nur genau dieselbe ID durch
   msg1.id      = 0x0B;                    // Selbe ID wie im Sender
   CAN_enableMOB(1, RECEIVE_DATA, msg1);   // Muss der auch aktiviert werden?


   CAN_enableMOB(0, TRANSMIT_DATA , msg0);

   sei();

   while (1) {  

      delay();

      if (++timer > 1000){
	     timer = 0;

	     if (LED1){
    	    LED1 = 0;
         }
         else{
            LED1 = 1;
         }

		 CAN_sendData (0, msg0.data );

      }
   }
   return 0;
}
